<?php
/* Eintrag an die Pinnwand
 *
 * Copyright (C) 2006 - 2008 Robert Bienert
 * http://freihoch2.de/opensource/pinnwand/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

include_once('util.inc.php');		// Hilfsbibliothek
include_once '../../lib/StoredQuizSession.php';	// Session

// Darstellung des Formulars
function pw_form($modus, $session, $feld) {
	$modus = htmlspecialchars($modus);

	$quizSession = is_object($session) ? '<p><span class="pwpflicht" title="Pflichtfeld Sicherheitsfrage">' .
					$session->displayCode().'</span></p>'
					: NULL;

	return '<form action="anheften" method="post">
<fieldset><legend>Dein Kommentar</legend>
<p><label class="pwpflicht" title="Pflichtfeld">Name <input type="text" name="pwn" size="20" value="' .
		htmlspecialchars($feld['pwn']) . '" /></label>
	<label>aus <input type="text" name="pws" size="25" value="' .
		htmlspecialchars($feld['pws']) . '" /></label></p>
<p><label>Email <input type="text" name="pwe" size="25" value="' .
		htmlspecialchars($feld['pwe']) . '"/> (optional)</label></p>
<p><label>Webseite <input type="text" name="pww" size="25" value="' .
		htmlspecialchars($feld['pww']) . '"/> (optional, <em>mit <kbd>http://</kbd> am Anfang</em>)</label></p>
<label for="pwk_" class="pwpflicht" title="Pflichtfeld">Der Zettel</label>
<textarea name="pwk" id="pwk_" rows="10" cols="80">' .
	htmlspecialchars($feld['pwk']) . '</textarea>' . $quizSession .
'<button type="submit" name="pwm" value="' . $modus . '">' .
	$modus . '</button>
<button type="reset">Formular Leeren</button>
</fieldset></form>';
}

// Jlog-Einstellungen
require('..'.DIRECTORY_SEPARATOR.'personal'.DIRECTORY_SEPARATOR.'settings.inc.php');

//--	main()
// Vorbelegung mit NULL, um uninitialisierten Variablen vorzubeugen
$req = array('pwn' => NULL, 'pwe' => NULL, 'pww' => NULL,
		'pwk' => NULL, 'pws' => STANDARD_STADT);
$req = array_merge($req, strip($_POST));

$c['meta']['title'] = 'An die Pinnwand heften';

// Erstellen eines Notizzettels
if (! array_key_exists('pwm', $req)) {
	$qs = new QuizSession();

	$c['main'] = '<h2>An die Pinnwand heften</h2>' .
			pw_form('Vorschau', &$qs, $req);
}
else {
	// Ueberpruefung der Pflichtfelder
	if (! ($req['pwn'] && $req['pwk'])) {
		$c['main'] = '<h2>An die Pinnwand heften</h2>' .
				'<p class="error">Einige ' .
				'Pflichtfelder sind nicht ' .
				'ausgef&#252;llt:</p>' .
				pw_form('Vorschau', NULL, $req);
	}
	// Vorschau
	elseif ($req['pwm'] == 'Vorschau') {
		$qs = new StoredQuizSession();

		if ($qs->validate()) {
			$qs->cleanup();

			$c['main'] = '<h2>An die Pinnwand heften</h2>' .
					'<h3>Vorschau</h3>' .
					pw_eintrag('jetzt', $req['pwn'],
						$req['pws'],
						$req['pww'], $req['pwk']) .
					pw_form('Anheften', NULL, $req);
		}
		else
			$c['main'] = '<h2>An die Pinnwand heften</h2>' .
				'<p class="error">Sicherheitsfrage ' .
				'falsch beantwortet, ' .
				'bitte zur&#252;ck.</p>';
	}
	// Anheften
	elseif ($req['pwm'] == 'Anheften') {
		$c['meta']['title'] = 'Angeheftet';

		if ($req['pws'] == STANDARD_STADT) $req['pws'] = NULL;

		$sql = new SQLQuery('INSERT INTO pinnwand (Datum, ' .
				'Name, Stadt, Email, Homepage, ' .
				'Kommentar) VALUES ' .
				'(NOW(), "Name", "Stadt", "Email", ' .
				'"Homepage", "Kommentar")',
				JLOG_DB_URL, JLOG_DB, 
				JLOG_DB_USER, JLOG_DB_PWD);
		$sql->bind(array('Name'		=> $req['pwn'],
				'Stadt'		=> $req['pws'],
				'Email'		=> $req['pwe'],
				'Homepage'	=> $req['pww'],
				'Kommentar'	=> $req['pwk']));
		if ($sql->exec() !== FALSE) {
			header('Location: '.JLOG_PATH.'/pinnwand/', 301);
			exit;
		}

		$c['main'] = '<p class="error">' .
				htmlspecialchars($sql->error()) . '</p>';
	}
}

require('..'.DIRECTORY_SEPARATOR.'scripts'.DIRECTORY_SEPARATOR.'do_template.php');
echo $body;
?>
