<?php
/* Hilfsbibliothek
 *
 * Copyright (C) 2006 - 2008 Robert Bienert
 * http://freihoch2.de/opensource/pinnwand/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

define('STANDARD_STADT', 'Stadt/Land');

// Ersatz fuer htmlspecialchars, der auch Sonderzeichen erlaubt
function pw_escape_html($s) {
	// match all "unauthorized" characters
	$s = preg_replace('/&(?![\#\d]+)/', '&amp;$1', $s);
	$s = str_replace('"', '&quot;', $s);
	$s = str_replace('<', '&lt;', $s);
	$s = str_replace('>', '&gt;', $s);

	return $s;
}

// Formatierung eines kompletten Pinnwand-Eintrages
function pw_eintrag($datum, $name, $stadt, $hp, $kommentar) {
	$nameKomplett = '';

	if ($hp)
		$nameKomplett = '<a href="' . pw_escape_html($hp) .
				'">';

	$nameKomplett .= pw_escape_html($name);

	if ($hp)
		$nameKomplett .= '</a>';

	if ($stadt && $stadt != STANDARD_STADT)
		$nameKomplett .= ' aus ' . pw_escape_html($stadt);

	return "<h3 class=\"pwautor\">$nameKomplett am $datum</h3>" .
		'<div class="pwkommentar">' . pw_kommentar($kommentar) .
		'</div>';
}

// Formatierung des reinen Kommentares
function pw_kommentar($k) {
	$k = '<p>' . pw_escape_html($k) . '</p>';
	return str_replace("\r\n", '</p><p>', $k);
}

include_once('sql.inc.php');
?>
